/* 

	"mb.maxcpp" - a basic c++ max external (with obex)
	based on graham wakefield's maxcpp example

	http://www.mat.ucsb.edu/~wakefield/maxcpp.htm
	http://www.grahamwakefield.net/

	www.olilarkin.co.uk
 
*/


#include "max.cpp.h"

class mbmaxcpp : public MaxCpp<mbmaxcpp>
{
public:
	
	mbmaxcpp(t_symbol * s = 0, long ac = 0, t_atom * av = 0);
	~mbmaxcpp() {};
	
	// methods:
	void bang();
	void test(t_symbol * s, long ac, t_atom * av);
};

mbmaxcpp::mbmaxcpp(t_symbol *s, long ac, t_atom *av)
: MaxCpp<mbmaxcpp>()
{		
	// remember to set any defaults before attribute args are processed!
	attr_args_process(this, ac, av);	
}

void mbmaxcpp :: bang()
{ 
	post("%s bang", maxClassName);
}

void mbmaxcpp :: test(t_symbol * s, long argc, t_atom * argv)
{ 
	post("%s %p call %s %i args", maxClassName, this, s->s_name, argc);
}

// called when library is loaded
extern "C" int main(void)
{	
	t_class * c = mbmaxcpp::maxMakeClass("mb.maxcpp");
	
	// add some methods:
	REGISTER_METHOD(mbmaxcpp, bang);
	REGISTER_METHOD_GIMME(mbmaxcpp, test);
	
	// register this as a class for Max UI & store static reference
	class_register(CLASS_BOX, c);
}