/* 
 
	"mb.mspcpp~" - a basic c++ msp external (with obex)
	based on graham wakefield's maxcpp example

	http://www.mat.ucsb.edu/~wakefield/maxcpp.htm
	http://www.grahamwakefield.net/

	www.olilarkin.co.uk
 
*/

#include "max.cpp.h"

class mbmspcpp : public MaxCpp<mbmspcpp>
{
public:
	
	mbmspcpp(t_symbol * s = 0, long ac = 0, t_atom * av = 0);
	~mbmspcpp();
	
	// callback for an MSP external:
	void doDsp(unsigned long vs, signalArray & ins, signalArray & outs);
};

mbmspcpp::mbmspcpp(t_symbol *s, long ac, t_atom *av)
: MaxCpp<mbmspcpp>() 
{		
	// create signal inlets & outlets:
	maxMSPCreate(2, 2);
	
	// remember to set any defaults before attribute args are processed!
	attr_args_process(this, ac, av);	
}

mbmspcpp :: ~mbmspcpp()
{
	// For all MSP objects: call this *before* freeing any memory etc:
	maxMSPEnd();
}

void mbmspcpp :: doDsp(unsigned long vs, signalArray & ins, signalArray & outs)
{
	// demo: copy inputs to outputs:
	for (unsigned int c=0;c<ins.size();c++) 
	{
		float * in = ins[c];
		float * out = outs[c];
		for (unsigned int i=0; i<vs; i++) { out[i] = in[i]; }
	}
}

// called when library is loaded
extern "C" int main(void)
{	
	// create class and register DSP callback:
	t_class	* c = mbmspcpp::maxMSPMakeClass("mb.mspcpp~", &mbmspcpp::doDsp);
	
	// register this as a class for Max UI & store static reference
	class_register(CLASS_BOX, c);
}
