/* 

	"mb.msp~" - a basic starting point msp external without obex, one signal input, one output

	www.olilarkin.co.uk

*/

#include "ext.h"    // Required for all Max external objects
#include "z_dsp.h"

void *mbmsp_class;

typedef struct _mbmsp 	// Data structure for this object
{
    t_pxobject x_obj; 
	double my_value;
} t_mbmsp;	

//prototypes for methods
void *mbmsp_new(double init_value);
void mbmsp_free(t_mbmsp *x);	
t_int *mbmsp_perform(t_int *w);
void mbmsp_dsp(t_mbmsp *x, t_signal **sp, short *count);
void mbmsp_assist(t_mbmsp *x, void *b, long m, long a, char *s);

int main(void)
{
	setup((t_messlist **)&mbmsp_class,(method)mbmsp_new, (method)dsp_free, 
		(short)sizeof(t_mbmsp), 0L, A_DEFFLOAT, 0);
	addmess((method)mbmsp_dsp, "dsp", A_CANT, 0);
	addmess((method)mbmsp_assist, "assist", A_CANT, 0);
	dsp_initclass();
	return 0;
}

// Create
void *mbmsp_new(double init_value)
{
    t_mbmsp *x = (t_mbmsp *)newobject(mbmsp_class);
	
	// second argument = number of signal inlets
    dsp_setup((t_pxobject *)x, 1);
	
	//initialise my_value
    x->my_value = init_value;

    // create one signal outlet
    outlet_new((t_object *)x, "signal");
    
    return (x);									// Return the pointer
}

// Destroy
void mbmsp_free(t_mbmsp *x)
{
	dsp_free((t_pxobject *)x);		// Always call dsp_free first in this routine
}

void mbmsp_dsp(t_mbmsp *x, t_signal **sp, short *count)
{
	dsp_add(mbmsp_perform, 4, x, sp[0]->s_vec, sp[1]->s_vec, sp[0]->s_n);
}

t_int *mbmsp_perform(t_int *w)
{
	t_mbmsp *x = (t_mbmsp *)(w[1]); // object is first arg 
	t_float *in = (t_float *)(w[2]);
	t_float *out1 = (t_float *)(w[3]);
	int i;
	int n = (int)(w[4]);
	
	for (i = 0; i < n; i++)
	{
		out1[i] = in[i];
	}

    return (w + 5); // always add one more than the 2nd argument in dsp_add()
}

void mbmsp_assist(t_mbmsp *x, void *b, long m, long a, char *s)
{
	if (m == 1) //input
	{
		sprintf(s,"Signal Input, Messages");
	}
	else
	{
		switch (a) {	
		case 0:
			sprintf(s,"Signal Output");
			break;
		}
	}
	
}
